SystemOrganization addCategory: #Sensors!

Object subclass: #Alarm
	instanceVariableNames: 'threshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!Alarm methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/29/2013 16:17'!
setAlarm: aThreshold 

threshold := aThreshold! !

Object subclass: #Device
	instanceVariableNames: 'name ip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!Device class methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 01:16'!
newFromXml: xmlString
	|device aName anIp doc stream|
	device := Device new.
	stream := xmlString readStream.
	doc := XMLDOMParser parseDocumentFrom: stream.
	device name: (doc findElementNamed: 'name') contentString.
	device ip: (doc findElementNamed: 'ip') contentString.
	^device.! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:04'!
asXml
	|stream|
	stream := WriteStream on: (String new: 1).
	stream nextPutAll: '<Device>'.
	stream nextPutAll: '<name>'.
	stream nextPutAll: name.
	stream nextPutAll: '</name>'.
	
	stream nextPutAll: '<ip>'.
	stream nextPutAll: ip.
	stream nextPutAll: '</ip>'.
	
	stream nextPutAll: '</Device>'.
	^stream contents.! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 00:40'!
initialize
	super initialize.! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 00:40'!
ip
	^ip! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 00:39'!
ip: anIp
	ip := anIp! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:29'!
name
	^name! !

!Device methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:29'!
name: aName
	name := aName! !

Object subclass: #DeviceManager
	instanceVariableNames: 'devices'
	classVariableNames: 'uniqueInstance'
	poolDictionaries: ''
	category: 'Sensors'!

!DeviceManager class methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:27'!
singleton
	uniqueInstance ifNil: [uniqueInstance := self basicNew initialize].
       ^uniqueInstance! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:21'!
addDevice: device
	devices at: (device name) put: device! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:29'!
devices
	^devices! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:30'!
getDevice: deviceName
	^devices at: deviceName.! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 6/30/2013 23:27'!
initialize
	devices := Dictionary new! !

!DeviceManager methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:22'!
removeDevice: deviceName
	devices removeKey: deviceName.! !

WARestfulHandler subclass: #DeviceWS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 22:56'!
addDevice
	|xml device|
    <post>
    <path: 'Device'>
	xml := (self requestContext request) rawBody.
	Transcript show: xml.
	device := Device newFromXml: xml.
	DeviceManager singleton addDevice: device.
	^'<Device>', (device name) , '</Device>'.! !

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 21:25'!
getDevice: deviceName
    <get>
    <path: 'Device/{1}'>
    <produces: 'text/xml'>
	^(DeviceManager singleton getDevice: deviceName) asXml.! !

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 21:25'!
getDevices
    <get>
    <path: 'Device'>
    <produces: 'text/xml'>
	|stream|
	stream := WriteStream on: (String new: 1).
	stream nextPutAll: '<Devices>'.
	DeviceManager singleton devices valuesDo: [:device | 
			stream nextPutAll: device asXml.
		].
	stream nextPutAll: '</Devices>'.
	^stream contents.! !

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/2/2013 21:02'!
postData: sensor
	|xml device|
    <post>
    <path: 'Data/{1}'>
	xml := (self requestContext request) rawBody.
	Transcript show: xml.
	^'<Data></Data>'.! !

!DeviceWS methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 21:25'!
removeDevice: deviceName
    <delete>
    <path: 'Device/{1}'>
    <produces: 'text/xml'>
   	DeviceManager singleton removeDevice: deviceName.
	^'<Device>', deviceName , '</Device>'.! !

TestCase subclass: #DeviceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sensors'!

!DeviceTest methodsFor: 'as yet unclassified' stamp: 'DanishShrestha 7/1/2013 10:05'!
testXml
	|xml dev stream xmlString doc device|
	xmlString := '<Device><name>arduino</name><ip>10.9.13.11</ip></Device>'.
	stream := xmlString readStream.
	doc := XMLDOMParser parseDocumentFrom: stream.
	device := Device new.
	device name: (doc findElementNamed: 'name') contentString.
	device ip: (doc findElementNamed: 'ip') contentString.
	
	Transcript show: device asXml.! !
